//
// Copyright 2021 Vulcanize, Inc.
//

import { Entity, PrimaryColumn, Column, Index } from 'typeorm';
import { bigintTransformer } from '@cerc-io/util';

@Entity()
@Index(['blockNumber'])
export class LendingMarket {
  @PrimaryColumn('varchar')
    id!: string;

  @PrimaryColumn('varchar', { length: 66 })
    blockHash!: string;

  @Column('integer')
    blockNumber!: number;

  @Column('varchar')
    currency!: string;

  @Column('numeric', { transformer: bigintTransformer })
    maturity!: bigint;

  @Column('boolean')
    isActive!: boolean;

  @Column('numeric', { transformer: bigintTransformer })
    volume!: bigint;

  @Column('numeric', { transformer: bigintTransformer })
    openingUnitPrice!: bigint;

  @Column('numeric', { transformer: bigintTransformer })
    lastLendUnitPrice!: bigint;

  @Column('numeric', { transformer: bigintTransformer })
    lastBorrowUnitPrice!: bigint;

  @Column('numeric', { transformer: bigintTransformer })
    offsetAmount!: bigint;

  @Column('boolean', { default: false })
    isPruned!: boolean;

  @Column('boolean', { default: false })
    isRemoved!: boolean;
}
