//
// Copyright 2021 Vulcanize, Inc.
//

import { Entity, PrimaryColumn, Column, Index } from 'typeorm';
import { bigintTransformer } from '@cerc-io/util';

@Entity()
@Index(['blockNumber'])
export class Liquidation {
  @PrimaryColumn('varchar')
    id!: string;

  @PrimaryColumn('varchar', { length: 66 })
    blockHash!: string;

  @Column('integer')
    blockNumber!: number;

  @Column('varchar')
    collateralCurrency!: string;

  @Column('varchar')
    debtCurrency!: string;

  @Column('numeric', { transformer: bigintTransformer })
    debtMaturity!: bigint;

  @Column('numeric', { transformer: bigintTransformer })
    debtAmount!: bigint;

  @Column('varchar')
    user!: string;

  @Column('numeric', { transformer: bigintTransformer })
    timestamp!: bigint;

  @Column('numeric', { transformer: bigintTransformer })
    _blockNumber!: bigint;

  @Column('varchar')
    txHash!: string;

  @Column('boolean', { default: false })
    isPruned!: boolean;

  @Column('boolean', { default: false })
    isRemoved!: boolean;
}
