//
// Copyright 2021 Vulcanize, Inc.
//

import { Entity, PrimaryColumn, Column, Index } from 'typeorm';
import { decimalTransformer, bigintTransformer } from '@cerc-io/util';
import { Decimal } from 'decimal.js';

@Entity()
@Index(['blockNumber'])
export class TransactionCandleStick {
  @PrimaryColumn('varchar')
    id!: string;

  @PrimaryColumn('varchar', { length: 66 })
    blockHash!: string;

  @Column('integer')
    blockNumber!: number;

  @Column('numeric', { transformer: bigintTransformer })
    interval!: bigint;

  @Column('varchar')
    currency!: string;

  @Column('numeric', { transformer: bigintTransformer })
    maturity!: bigint;

  @Column('numeric', { transformer: bigintTransformer })
    timestamp!: bigint;

  @Column('numeric', { transformer: bigintTransformer })
    open!: bigint;

  @Column('numeric', { transformer: bigintTransformer })
    close!: bigint;

  @Column('numeric', { transformer: bigintTransformer })
    high!: bigint;

  @Column('numeric', { transformer: bigintTransformer })
    low!: bigint;

  @Column('numeric', { transformer: decimalTransformer })
    average!: Decimal;

  @Column('numeric', { transformer: bigintTransformer })
    volume!: bigint;

  @Column('numeric', { transformer: bigintTransformer })
    volumeInFV!: bigint;

  @Column('varchar')
    lendingMarket!: string;

  @Column('boolean', { default: false })
    isPruned!: boolean;

  @Column('boolean', { default: false })
    isRemoved!: boolean;
}
