//
// Copyright 2021 Vulcanize, Inc.
//

import { Entity, PrimaryColumn, Column, Index } from 'typeorm';
import { TransferType } from '../types';
import { bigintTransformer } from '@cerc-io/util';

@Entity()
@Index(['blockNumber'])
export class Transfer {
  @PrimaryColumn('varchar')
    id!: string;

  @PrimaryColumn('varchar', { length: 66 })
    blockHash!: string;

  @Column('integer')
    blockNumber!: number;

  @Column('varchar')
    user!: string;

  @Column('varchar')
    currency!: string;

  @Column('numeric', { transformer: bigintTransformer })
    amount!: bigint;

  @Column({ type: 'enum', enum: TransferType })
    transferType!: TransferType;

  @Column('numeric', { transformer: bigintTransformer })
    timestamp!: bigint;

  @Column('numeric', { transformer: bigintTransformer })
    _blockNumber!: bigint;

  @Column('varchar')
    txHash!: string;

  @Column('boolean', { default: false })
    isPruned!: boolean;

  @Column('boolean', { default: false })
    isRemoved!: boolean;
}
